# -*- coding: utf-8 -*-
import sys
import os
import time
from PyQt5.QtWidgets import *
from PyQt5 import uic, QtCore, QtGui, QtWidgets

form_class = uic.loadUiType("winsearch5.ui")[0]

class MyWindow(QMainWindow, form_class):
    def __init__(self):
        super().__init__()
        self.setupUi(self)

        self.pushButton.clicked.connect(self.searchFile)
        self.toolButton.clicked.connect(self.selectFolder)
        self.toolButton_2.clicked.connect(self.selectSaveFile)
        self.pushButton_2.clicked.connect(self.saveFile)

    def searchFile(self):
        global folder_size_total

        folder_size_total = 0

        if self.lineEdit_2.text():
            folder = self.lineEdit_2.text()
        else:
            folder = 'F:/Download'

        if self.lineEdit.text():
            file_size_input = self.lineEdit.text()
            if int(file_size_input) < 1000:
                print("파일 검색 사이즈가 너무 작습니다.(1000 bytes 이상)")
                self.textEdit.setText("파일 검색 사이즈가 너무 작습니다.(1000 bytes 이상)")
                self.clickMethod()
            else:
                self.textEdit.clear()
                try:
                    for (path, dirs, files) in os.walk(folder):
                        for file in files:
                            try:
                                filename = os.path.join(path, file)
                                file_size = os.path.getsize(filename)
                                if file_size > int(file_size_input):
                                    print("파일명 : ", filename, "\t", "파일크기 : ", file_size, "\n")
                                    self.textEdit.append(str(filename) + "\t" + str(file_size) + " bytes")
                                folder_size_total += os.path.getsize(filename)
                            except FileNotFoundError:
                                pass
                        time.sleep(0.1)
                    time.sleep(0.1)
                    self.textEdit.append("\n폴더전체크기 : " + str(folder_size_total) + " bytes")

                    print(folder, "폴더전체크기 : ", folder_size_total, " Bytes")
                except KeyboardInterrupt:
                    sys.exit()

        else:
            self.textEdit.setText("파일 크기를 입력해 주세요.(1000 bytes 이상)")

    def selectFolder(self):
        directory = str(QtWidgets.QFileDialog.getExistingDirectory())
        self.lineEdit_2.setText('{}'.format(directory))

    def selectSaveFile(self):
        savefilename = QFileDialog.getSaveFileName(self, "Save File")
        print(type(savefilename))
        self.lineEdit_3.setText('{}'.format(savefilename[0]))

    def saveFile(self):
        savefilename = self.lineEdit_3.text()
        readfile = self.textEdit.toPlainText()
        if savefilename and readfile:
            print(type(savefilename))
            try:
                with open(savefilename, 'w+', encoding='utf8') as out:
                    out.write(readfile + "\n")
                out.close()
                self.clickMethod2()
                self.lineEdit_3.setText("")
            except:
                print("파일이 저장되지 않고, 에러가 발생하였습니다.")
        else:
            QMessageBox.about(self, "경고!!", "검색 결과가 없거나, 저정할 파일을 지정하지 않았습니다.")

    def clickMethod(self):
        QMessageBox.about(self, "주의!!", "파일 검색 사이즈가 너무 작습니다. (1000 bytes 이상)")

    def clickMethod2(self):
        QMessageBox.about(self, "파일저장!!", "파일이 저장되었습니다.")

app=QApplication(sys.argv)
window = MyWindow()
window.show()
print("Before event loop")
app.exec_()
print("After event loop")